"""
    Bamboo Flexibility API

     This API provides access to flexibility assets managed by Bamboo Energy: - Create and list flexibility sites & assets - Obtain activations for specific assets - Post and get measurements for specific assets   # noqa: E501

    The version of the OpenAPI document: 1.4.1
    Contact: development@bambooenergy.tech
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bambooapi_client.api_client import ApiClient, Endpoint as _Endpoint
from bambooapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from bambooapi_client.model.activation_state import ActivationState
from bambooapi_client.model.baseline_model import BaselineModel
from bambooapi_client.model.flexibility_model import FlexibilityModel
from bambooapi_client.model.http400_bad_request import HTTP400BadRequest
from bambooapi_client.model.http401_unauthorized import HTTP401Unauthorized
from bambooapi_client.model.http403_forbidden import HTTP403Forbidden
from bambooapi_client.model.http404_not_found import HTTP404NotFound
from bambooapi_client.model.http_validation_error import HTTPValidationError
from bambooapi_client.model.site import Site
from bambooapi_client.model.site_create import SiteCreate
from bambooapi_client.model.site_data_point import SiteDataPoint
from bambooapi_client.model.site_list_item import SiteListItem
from bambooapi_client.model.site_update import SiteUpdate
from bambooapi_client.model.thermal_zone import ThermalZone


class SitesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __create_site(
            self,
            site_create,
            **kwargs
        ):
            """Create a Site  # noqa: E501

            Create a Site with all the information:  - **site_name**: each site must have a name - **client_id**: each site must be associated with a client - **prosumer_id**: each site must be associated with a prosumer - **weather_id**: each site must be associated with a weather station - **tariff_id**: each site must be associated with an electricity tariff - **energy_injection**: If True, energy can be injected into the grid - **location**: a site can optionally have a location - **country**: a site can optionally have a country - **country_code**: a site can optionally have an ISO 3166 country code - **timezone**: a site can optionally have a time zone - **latitude**: a site can optionally have a latitude - **longitude**: a site can optionally have a longitude - **elevation**: a site can optionally have an elevation - **microgrid**: a site must have a microgrid JSON describing devices and sensors  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.create_site(site_create, async_req=True)
            >>> result = thread.get()

            Args:
                site_create (SiteCreate):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Site
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_create'] = \
                site_create
            return self.call_with_http_info(**kwargs)

        self.create_site = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites',
                'operation_id': 'create_site',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_create',
                ],
                'required': [
                    'site_create',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_create':
                        (SiteCreate,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'site_create': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__create_site
        )

        def __delete_site(
            self,
            site_id,
            **kwargs
        ):
            """Delete a Site  # noqa: E501

            Delete a Site.  **WARNING!: Site deletion is PERMANENT!** (no way to recover deleted site)  **WARNING!: Deleting a Site does not delete the associated measurements,  forecasts or tariffs!**  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.delete_site(site_id, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Site
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            return self.call_with_http_info(**kwargs)

        self.delete_site = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}',
                'operation_id': 'delete_site',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__delete_site
        )

        def __get_site_id_by_name(
            self,
            site_name,
            **kwargs
        ):
            """Retrieve Site ID given a Site Name  # noqa: E501

            Retrieve Site ID given a Site Name.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_site_id_by_name(site_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_name (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                int
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_name'] = \
                site_name
            return self.call_with_http_info(**kwargs)

        self.get_site_id_by_name = _Endpoint(
            settings={
                'response_type': (int,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/id/{site_name}',
                'operation_id': 'get_site_id_by_name',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_name',
                ],
                'required': [
                    'site_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_name':
                        (str,),
                },
                'attribute_map': {
                    'site_name': 'site_name',
                },
                'location_map': {
                    'site_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_site_id_by_name
        )

        def __insert_device_forecasts(
            self,
            site_id,
            device_name,
            site_data_point,
            **kwargs
        ):
            """Insert forecast for a given site and device  # noqa: E501

            Insert forecasts for a given site and device.  - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.insert_device_forecasts(site_id, device_name, site_data_point, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):
                site_data_point ([SiteDataPoint]):

            Keyword Args:
                horizon (str): [optional] if omitted the server will use the default value of "day-ahead"
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [SiteDataPoint]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            kwargs['site_data_point'] = \
                site_data_point
            return self.call_with_http_info(**kwargs)

        self.insert_device_forecasts = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/forecasts/{device_name}',
                'operation_id': 'insert_device_forecasts',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'nullable': [
                ],
                'enum': [
                    'horizon',
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('horizon',): {

                        "INTRA-DAY": "intra-day",
                        "DAY-AHEAD": "day-ahead"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'site_data_point':
                        ([SiteDataPoint],),
                    'horizon':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'site_data_point': 'body',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__insert_device_forecasts
        )

        def __insert_device_measurements(
            self,
            site_id,
            device_name,
            site_data_point,
            **kwargs
        ):
            """Insert measurement for a given site and device  # noqa: E501

            Insert measurements for a given site and device.  - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.insert_device_measurements(site_id, device_name, site_data_point, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):
                site_data_point ([SiteDataPoint]):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [SiteDataPoint]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            kwargs['site_data_point'] = \
                site_data_point
            return self.call_with_http_info(**kwargs)

        self.insert_device_measurements = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/measurements/{device_name}',
                'operation_id': 'insert_device_measurements',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'site_data_point':
                        ([SiteDataPoint],),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'site_data_point': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__insert_device_measurements
        )

        def __list_devices(
            self,
            site_id,
            **kwargs
        ):
            """List all devices for a given Site  # noqa: E501

            List all devices for a given Site.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.list_devices(site_id, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):

            Keyword Args:
                device_type (str): [optional] if omitted the server will use the default value of "meters"
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                dict
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            return self.call_with_http_info(**kwargs)

        self.list_devices = _Endpoint(
            settings={
                'response_type': (dict,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices',
                'operation_id': 'list_devices',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_type',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                    'device_type',
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                    ('device_type',): {

                        "METERS": "meters",
                        "SHIFTABLE_LOADS": "shiftable_loads",
                        "BATTERIES": "batteries",
                        "PV_SYSTEMS": "pv_systems",
                        "EV_CHARGERS": "ev_chargers",
                        "THERMAL_LOADS": "thermal_loads",
                        "THERMAL_COMFORT_DEVICES": "thermal_comfort_devices"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_type':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_type': 'device_type',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_type': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__list_devices
        )

        def __list_sites(
            self,
            **kwargs
        ):
            """List all Sites  # noqa: E501

            List all Sites.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.list_sites(async_req=True)
            >>> result = thread.get()


            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [SiteListItem]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            return self.call_with_http_info(**kwargs)

        self.list_sites = _Endpoint(
            settings={
                'response_type': ([SiteListItem],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites',
                'operation_id': 'list_sites',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__list_sites
        )

        def __list_zones(
            self,
            site_id,
            **kwargs
        ):
            """List all zones for a given Site  # noqa: E501

            List all zones for a given Site.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.list_zones(site_id, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [ThermalZone]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            return self.call_with_http_info(**kwargs)

        self.list_zones = _Endpoint(
            settings={
                'response_type': ([ThermalZone],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/zones',
                'operation_id': 'list_zones',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__list_zones
        )

        def __read_baseline_model(
            self,
            site_id,
            device_name,
            **kwargs
        ):
            """Return Baseline Model trained parameters for a given site and device  # noqa: E501

            Return Baseline Model trained parameters for a given site and device.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_baseline_model(site_id, device_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):

            Keyword Args:
                horizon (str): [optional] if omitted the server will use the default value of "day-ahead"
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                BaselineModel
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            return self.call_with_http_info(**kwargs)

        self.read_baseline_model = _Endpoint(
            settings={
                'response_type': (BaselineModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/models/baseline/{device_name}',
                'operation_id': 'read_baseline_model',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                    'horizon',
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('horizon',): {

                        "DAY-AHEAD": "day-ahead",
                        "INTRA-DAY": "intra-day"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'horizon':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_baseline_model
        )

        def __read_device(
            self,
            site_id,
            device_name,
            **kwargs
        ):
            """Return description of selected Device  # noqa: E501

            Return description of selected Device.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_device(site_id, device_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                dict
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            return self.call_with_http_info(**kwargs)

        self.read_device = _Endpoint(
            settings={
                'response_type': (dict,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}',
                'operation_id': 'read_device',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_device
        )

        def __read_device_activations(
            self,
            site_id,
            device_name,
            **kwargs
        ):
            """Return activation state for a given site and device  # noqa: E501

            Return activation state for a given site and device.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_device_activations(site_id, device_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ActivationState
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            return self.call_with_http_info(**kwargs)

        self.read_device_activations = _Endpoint(
            settings={
                'response_type': (ActivationState,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/activations/{device_name}',
                'operation_id': 'read_device_activations',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_device_activations
        )

        def __read_device_forecasts(
            self,
            site_id,
            device_name,
            **kwargs
        ):
            """Return forecast for a given site and device  # noqa: E501

            Return forecast for a given site and device.  - **Timestamps are ordered from oldest to newest** - **Data is returned with the same sign convention as when pushed** (not transformation applied)  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_device_forecasts(site_id, device_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):

            Keyword Args:
                horizon (str): [optional] if omitted the server will use the default value of "day-ahead"
                period (str): [optional] if omitted the server will use the default value of "Recent"
                period_start (str): Either a timestamp in RFC3339 format ('YYYY-MM-DDT00:00:00Z') or a duration ('-1mo', '-1d', '-12h'). [optional]
                period_stop (str): Either a timestamp in RFC3339 format ('YYYY-MM-DDT00:00:00Z') or a duration ('1mo', '1d', '12h'). [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [SiteDataPoint]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            return self.call_with_http_info(**kwargs)

        self.read_device_forecasts = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/forecasts/{device_name}',
                'operation_id': 'read_device_forecasts',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'horizon',
                    'period',
                    'period_start',
                    'period_stop',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                    'horizon',
                    'period',
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('horizon',): {

                        "INTRA-DAY": "intra-day",
                        "DAY-AHEAD": "day-ahead"
                    },
                    ('period',): {

                        "RECENT": "Recent",
                        "CUSTOMRANGE": "CustomRange"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'horizon':
                        (str,),
                    'period':
                        (str,),
                    'period_start':
                        (str,),
                    'period_stop':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                    'period': 'period',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'horizon': 'query',
                    'period': 'query',
                    'period_start': 'query',
                    'period_stop': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_device_forecasts
        )

        def __read_device_measurements(
            self,
            site_id,
            device_name,
            **kwargs
        ):
            """Return measurement for a given site and device  # noqa: E501

            Return measurement for a given site and device.  - **Timestamps are ordered from oldest to newest** - **Data is returned with the same sign convention as when pushed** (not transformation applied)  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_device_measurements(site_id, device_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):

            Keyword Args:
                period (str): [optional] if omitted the server will use the default value of "Recent"
                period_start (str): Either a timestamp in RFC3339 format ('YYYY-MM-DDT00:00:00Z') or a duration ('-1mo', '-1d', '-12h'). [optional]
                period_stop (str): Either a timestamp in RFC3339 format ('YYYY-MM-DDT00:00:00Z') or a duration ('1mo', '1d', '12h'). [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                [SiteDataPoint]
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            return self.call_with_http_info(**kwargs)

        self.read_device_measurements = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/measurements/{device_name}',
                'operation_id': 'read_device_measurements',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'period',
                    'period_start',
                    'period_stop',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                    'period',
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('period',): {

                        "RECENT": "Recent",
                        "CUSTOMRANGE": "CustomRange"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'period':
                        (str,),
                    'period_start':
                        (str,),
                    'period_stop':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'period': 'period',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'period': 'query',
                    'period_start': 'query',
                    'period_stop': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_device_measurements
        )

        def __read_flexibility_model(
            self,
            site_id,
            zone_name,
            **kwargs
        ):
            """Return Thermal Flexibility Model trained parameters for a     given site and zone  # noqa: E501

            Return Thermal Flexibility Model trained parameters for a given site and zone.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_flexibility_model(site_id, zone_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                zone_name (str):

            Keyword Args:
                horizon (str): [optional] if omitted the server will use the default value of "day-ahead"
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                FlexibilityModel
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['zone_name'] = \
                zone_name
            return self.call_with_http_info(**kwargs)

        self.read_flexibility_model = _Endpoint(
            settings={
                'response_type': (FlexibilityModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/models/flexibility/thermal/{zone_name}',
                'operation_id': 'read_flexibility_model',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                ],
                'nullable': [
                ],
                'enum': [
                    'horizon',
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('horizon',): {

                        "DAY-AHEAD": "day-ahead",
                        "INTRA-DAY": "intra-day"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'horizon':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_flexibility_model
        )

        def __read_site(
            self,
            site_id,
            **kwargs
        ):
            """Info about a specific Site  # noqa: E501

            Info about a specific Site.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_site(site_id, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Site
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            return self.call_with_http_info(**kwargs)

        self.read_site = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}',
                'operation_id': 'read_site',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_site
        )

        def __read_zone(
            self,
            site_id,
            zone_name,
            **kwargs
        ):
            """Return description of selected Zone  # noqa: E501

            Return description of selected Zone.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.read_zone(site_id, zone_name, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                zone_name (str):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                ThermalZone
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['zone_name'] = \
                zone_name
            return self.call_with_http_info(**kwargs)

        self.read_zone = _Endpoint(
            settings={
                'response_type': (ThermalZone,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/zones/{zone_name}',
                'operation_id': 'read_zone',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__read_zone
        )

        def __update_baseline_model(
            self,
            site_id,
            device_name,
            baseline_model,
            **kwargs
        ):
            """Set Baseline Model parameters for a given site and device  # noqa: E501

            Set Baseline Model parameters for a given site and device.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_baseline_model(site_id, device_name, baseline_model, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                device_name (str):
                baseline_model (BaselineModel):

            Keyword Args:
                horizon (str): [optional] if omitted the server will use the default value of "day-ahead"
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                BaselineModel
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['device_name'] = \
                device_name
            kwargs['baseline_model'] = \
                baseline_model
            return self.call_with_http_info(**kwargs)

        self.update_baseline_model = _Endpoint(
            settings={
                'response_type': (BaselineModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/models/baseline/{device_name}',
                'operation_id': 'update_baseline_model',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'baseline_model',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'baseline_model',
                ],
                'nullable': [
                ],
                'enum': [
                    'horizon',
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('horizon',): {

                        "DAY-AHEAD": "day-ahead",
                        "INTRA-DAY": "intra-day"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'baseline_model':
                        (BaselineModel,),
                    'horizon':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'baseline_model': 'body',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_baseline_model
        )

        def __update_flexibility_model(
            self,
            site_id,
            zone_name,
            flexibility_model,
            **kwargs
        ):
            """Set Thermal Flexibility Model parameters for a given site and zone  # noqa: E501

            Set Thermal Flexibility Model parameters for a given site and zone.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_flexibility_model(site_id, zone_name, flexibility_model, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                zone_name (str):
                flexibility_model (FlexibilityModel):

            Keyword Args:
                horizon (str): [optional] if omitted the server will use the default value of "day-ahead"
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                FlexibilityModel
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['zone_name'] = \
                zone_name
            kwargs['flexibility_model'] = \
                flexibility_model
            return self.call_with_http_info(**kwargs)

        self.update_flexibility_model = _Endpoint(
            settings={
                'response_type': (FlexibilityModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/models/flexibility/thermal/{zone_name}',
                'operation_id': 'update_flexibility_model',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'flexibility_model',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                    'flexibility_model',
                ],
                'nullable': [
                ],
                'enum': [
                    'horizon',
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                    ('horizon',): {

                        "DAY-AHEAD": "day-ahead",
                        "INTRA-DAY": "intra-day"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'flexibility_model':
                        (FlexibilityModel,),
                    'horizon':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'flexibility_model': 'body',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_flexibility_model
        )

        def __update_site(
            self,
            site_id,
            site_update,
            **kwargs
        ):
            """Update an existing Site  # noqa: E501

            Update information about a Site.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.update_site(site_id, site_update, async_req=True)
            >>> result = thread.get()

            Args:
                site_id (int):
                site_update (SiteUpdate):

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                Site
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['site_id'] = \
                site_id
            kwargs['site_update'] = \
                site_update
            return self.call_with_http_info(**kwargs)

        self.update_site = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}',
                'operation_id': 'update_site',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'site_update',
                ],
                'required': [
                    'site_id',
                    'site_update',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'site_update':
                        (SiteUpdate,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                    'site_update': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__update_site
        )
